//+------------------------------------------------------------------+
//|                                                 N&P with Tim.mq4 |
//|                                                  Nick Lougovskoi |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Nick Lougovskoi"
#property link "http://www.metaquotes.net"
//----
extern bool BuyFlag = true;   
extern bool SellFlag = true;  
extern double TopFilter_Ok = 3;
extern double BotFilter_Ok = 0;
extern double Lots = 0.01;
extern int TakeProfit = 20;
double ema7,ema14,sma50;						//move these up alongside your extern variables declarations for now..***done
int sSignal;								// "
int iOrders;								// "
int iDuplicateOrders;							// "
double NUM_CURRENCY_PAIRS;
//----

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }



//-------------------Overview of Program Design

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()

//----------------Order Count / Limit Direction to 1 trade only---------------+
//***CB: i understand no need to declare anything here, as variables are either globally declared above, or within specific functions.
for (int c=0;c<NUM_CURRENCY_PAIRS;c++) 

int Order_Check_Buys (int c)
    {
     int result = 0;
     if (OrderSelect (c,SELECT_BY_POS,MODE_TRADES)==true)        //this checks if an open order exists, it doesn't check direction
     if (OrderType () ==OP_BUY) result ++;
     return(result);
    }
    
    int Order_Check_Sells (int c)  
    {
    int result = 0;
    if (OrderSelect (c,SELECT_BY_POS,MODE_TRADES)==true);
    if (OrderType () ==OP_SELL) result ++;
    return (result)
    }
    //-----------------------------------------end----------------------------------------
  
  
  
  
  
  
  
//-------------------------------------------------------------+
   {
   sSignal = fnGenerateSignal();						// change this to "sGignal = fnGenerateSignal();" ***done
   if (fnShouldWeTrade())
    fnTrade();                                                            // change this to "fnTrade();"**done
   return(0);
   }

                                 //***CB: i added "}" as we need to close the int start() function, and the way i understand it is other functions we built should be outside of the start func.
//+------------------------------------------------------------------+
//| Nick's functions                                                 |
//+------------------------------------------------------------------+
int fnGenerateSignal()						//change this to "string fnGenerateSignal()"***CB: this is how it was, just a space between fnGenerateSignal and ()
 {
   ema7 = iMA(Symbol(),PERIOD_M5,7,0,MODE_EMA,PRICE_CLOSE,0);      	// This is not "declaration" of variables - its is setting them.
   ema14 = iMA(Symbol(),PERIOD_M5,14,0,MODE_EMA,PRICE_CLOSE,0);   	 //  "....***CB: I moved these here as they belong to this fn
   sma50 = iMA(Symbol(),PERIOD_M5,50,0,MODE_SMA,PRICE_CLOSE,0);    	//
  if((ema7>ema14)&&(ema14>sma50)&&(Ask<TopFilter_Ok))  
     return(1);           //OP_BUY = 1
  if((ema7<ema14)&&(ema14<sma50)&&(Bid>BotFilter_Ok))		
    return(-1);          //OP_SELL = -1
  return(0);              //PASS  = 0
 }
//-----------------
bool fnShouldWeTrade() //change this to "bool fnShouldWeTrade()"***done
 {
 if ((sSignal != 1) && (sSignal != -1))
  return(false); 
 if (sSignal == 1)
  if (!BuyFlag)
   return(false);
 if (sSignal == -1)
  if(!SellFlag)
   return(false);
 if (fnOrderDuplicate())
  return(false);
 return(true);
 }
//-----------------------------------------------------+


bool fnOrderDuplicate()	//change this to "bool fnOrderDuplicate()"***done
 {
 string order_type = OrderType();
  iDuplicateOrders = 0;
  iOrders = OrdersTotal()-1;
  for (int i=iOrders; i>=0; i--)
   {
    OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
    if ((OrderSymbol() == Symbol()) && (OrderType() == sSignal))        //this is where the problem is, OrderType should not == sSignal. problem solved with making sSignal an int
        iDuplicateOrders++;
   }
  if (iDuplicateOrders == 0)
   return(false);
  return(true);
 }

//----
int fnTrade()							//change this to "int fnTrade()"****done
 {
  if (sSignal == 1)
   OrderSend(Symbol(),OP_BUY,Lots,Ask,5,0,Bid+TakeProfit*Point,"Nikos First EA",0,0,Green);
  else
   OrderSend(Symbol(),OP_SELL,Lots,Bid,5,0,Bid+TakeProfit*Point,"Nikos First EA",0,0,Green);
  return(0);
 }

//---- THE END ----